#include "MathUtils.h"

/*
// special tables for calculating the goplane's orientation.  
// X coordinate
const s16 goplanes_costable32[32] = 
{
    (s16)(1.35 * 128) >> 4, // facing right
    (s16)(1.35 * 125) >> 4,
    (s16)(1.35 * 118) >> 4,
    (s16)(1.35 * 106) >> 4,
    (s16)(1.35 * 90) >> 4,
    (s16)(1.35 * 71) >> 4,
    (s16)(1.35 * 48) >> 4,
    (s16)(1.35 * 24) >> 4,
    0,  // facing straight up
    (s16)(1.35 * -24) >> 4,
    (s16)(1.35 * -48) >> 4,
    (s16)(1.35 * -71) >> 4,
    (s16)(1.35 * -90) >> 4,
    (s16)(1.35 * -106) >> 4,
    (s16)(1.35 * -118) >> 4,
    (s16)(1.35 * -125) >> 4,
    (s16)(1.35 * -128) >> 4, // facing left
    (s16)(1.35 * -125) >> 4,
    (s16)(1.35 * -118) >> 4,
    (s16)(1.35 * -106) >> 4,
    (s16)(1.35 * -90) >> 4,
    (s16)(1.35 * -71) >> 4,
    (s16)(1.35 * -48) >> 4,
    (s16)(1.35 * -24) >> 4,
    0, // facing straight down
    (s16)(1.35 * 24) >> 4,
    (s16)(1.35 * 48) >> 4,
    (s16)(1.35 * 71) >> 4,
    (s16)(1.35 * 90) >> 4,
    (s16)(1.35 * 106) >> 4,
    (s16)(1.35 * 118) >> 4,
    (s16)(1.35 * 125) >> 4,
};

// Y coordinate
const s16 goplanes_sintable32[32] = 
{
    0, // facing right
    (s16)(1.35 * 24) >> 4,
    (s16)(1.35 * 48) >> 4,
    (s16)(1.35 * 71) >> 4,
    (s16)(1.35 * 90) >> 4,
    (s16)(1.35 * 106) >> 4,
    (s16)(1.35 * 118) >> 4,
    (s16)(1.35 * 125) >> 4,
    (s16)(1.35 * 128) >> 4, // facing straight up
    (s16)(1.35 * 125) >> 4,
    (s16)(1.35 * 118) >> 4,
    (s16)(1.35 * 106) >> 4,
    (s16)(1.35 * 90) >> 4,
    (s16)(1.35 * 71) >> 4,
    (s16)(1.35 * 48) >> 4,
    (s16)(1.35 * 24) >> 4,
    0, // facing left
    (s16)(1.35 * -24) >> 4,
    (s16)(1.35 * -48) >> 4,
    (s16)(1.35 * -71) >> 4,
    (s16)(1.35 * -90) >> 4,
    (s16)(1.35 * -106) >> 4,
    (s16)(1.35 * -118) >> 4,
    (s16)(1.35 * -125) >> 4,
    (s16)(1.35 * -128) >> 4, // facing straight down
    (s16)(1.35 * -125) >> 4,
    (s16)(1.35 * -118) >> 4,
    (s16)(1.35 * -106) >> 4,
    (s16)(1.35 * -90) >> 4,
    (s16)(1.35 * -71) >> 4,
    (s16)(1.35 * -48) >> 4,
    (s16)(1.35 * -24) >> 4,
};
*/
const s16 goplanes_costable32[32] = 
{
    10,
    10,
    9,
    8,
    7,
    6,
    4,
    2,
    0,
    -2,
    -4,
    -6,
    -7,
    -8,
    -9,
    -10,
    -10,
    -10,
    -9,
    -8,
    -7,
    -6,
    -4,
    -2,
    0,
    2,
    4,
    6,
    7,
    8,
    9,
    10,
};
const s16 goplanes_sintable32[32] = 
{
    0,
    2,
    4,
    6,
    7,
    8,
    9,
    10,
    10,
    10,
    9,
    8,
    7,
    6,
    4,
    2,
    0,
    -2,
    -4,
    -6,
    -7,
    -8,
    -9,
    -10,
    -10,
    -10,
    -9,
    -8,
    -7,
    -6,
    -4,
    -2,
};

/*
// special tables for calculating the goplane's orientation.  
// X coordinate
const s16 goplanes_slow_costable32[32] = 
{
    (s16)(0.70 * 128) >> 4, // facing right
    (s16)(0.70 * 125) >> 4,
    (s16)(0.70 * 118) >> 4,
    (s16)(0.70 * 106) >> 4,
    (s16)(0.70 * 90) >> 4,
    (s16)(0.70 * 71) >> 4,
    (s16)(0.70 * 48) >> 4,
    (s16)(0.70 * 24) >> 4,
    0,  // facing straight up
    (s16)(0.70 * -24) >> 4,
    (s16)(0.70 * -48) >> 4,
    (s16)(0.70 * -71) >> 4,
    (s16)(0.70 * -90) >> 4,
    (s16)(0.70 * -106) >> 4,
    (s16)(0.70 * -118) >> 4,
    (s16)(0.70 * -125) >> 4,
    (s16)(0.70 * -128) >> 4, // facing left
    (s16)(0.70 * -125) >> 4,
    (s16)(0.70 * -118) >> 4,
    (s16)(0.70 * -106) >> 4,
    (s16)(0.70 * -90) >> 4,
    (s16)(0.70 * -71) >> 4,
    (s16)(0.70 * -48) >> 4,
    (s16)(0.70 * -24) >> 4,
    0, // facing straight down
    (s16)(0.70 * 24) >> 4,
    (s16)(0.70 * 48) >> 4,
    (s16)(0.70 * 71) >> 4,
    (s16)(0.70 * 90) >> 4,
    (s16)(0.70 * 106) >> 4,
    (s16)(0.70 * 118) >> 4,
    (s16)(0.70 * 125) >> 4,
};

// Y coordinate
const s16 goplanes_slow_sintable32[32] = 
{
    0, // facing right
    (s16)(0.70 * 24) >> 4,
    (s16)(0.70 * 48) >> 4,
    (s16)(0.70 * 71) >> 4,
    (s16)(0.70 * 90) >> 4,
    (s16)(0.70 * 106) >> 4,
    (s16)(0.70 * 118) >> 4,
    (s16)(0.70 * 125) >> 4,
    (s16)(0.70 * 128) >> 4, // facing straight up
    (s16)(0.70 * 125) >> 4,
    (s16)(0.70 * 118) >> 4,
    (s16)(0.70 * 106) >> 4,
    (s16)(0.70 * 90) >> 4,
    (s16)(0.70 * 71) >> 4,
    (s16)(0.70 * 48) >> 4,
    (s16)(0.70 * 24) >> 4,
    0, // facing left
    (s16)(0.70 * -24) >> 4,
    (s16)(0.70 * -48) >> 4,
    (s16)(0.70 * -71) >> 4,
    (s16)(0.70 * -90) >> 4,
    (s16)(0.70 * -106) >> 4,
    (s16)(0.70 * -118) >> 4,
    (s16)(0.70 * -125) >> 4,
    (s16)(0.70 * -128) >> 4, // facing straight down
    (s16)(0.70 * -125) >> 4,
    (s16)(0.70 * -118) >> 4,
    (s16)(0.70 * -106) >> 4,
    (s16)(0.70 * -90) >> 4,
    (s16)(0.70 * -71) >> 4,
    (s16)(0.70 * -48) >> 4,
    (s16)(0.70 * -24) >> 4,
};
*/
const s16 goplanes_slow_costable32[32] = 
{
    5,
    5,
    5,
    4,
    3,
    3,
    2,
    1,
    0,
    -1,
    -2,
    -3,
    -3,
    -4,
    -5,
    -5,
    -5,
    -5,
    -5,
    -4,
    -3,
    -3,
    -2,
    -1,
    0,
    1,
    2,
    3,
    3,
    4,
    5,
    5,
};
const s16 goplanes_slow_sintable32[32] = 
{
    0,
    1,
    2,
    3,
    3,
    4,
    5,
    5,
    5,
    5,
    5,
    4,
    3,
    3,
    2,
    1,
    0,
    -1,
    -2,
    -3,
    -3,
    -4,
    -5,
    -5,
    -5,
    -5,
    -5,
    -4,
    -3,
    -3,
    -2,
    -1,
};


/*
// special tables for calculating the goplane's orientation.  
// X coordinate
const s16 goplanes_fast_costable32[32] = 
{
    (s16)(2.00 * 128) >> 4, // facing right
    (s16)(2.00 * 125) >> 4,
    (s16)(2.00 * 118) >> 4,
    (s16)(2.00 * 106) >> 4,
    (s16)(2.00 * 90) >> 4,
    (s16)(2.00 * 71) >> 4,
    (s16)(2.00 * 48) >> 4,
    (s16)(2.00 * 24) >> 4,
    0,  // facing straight up
    (s16)(2.00 * -24) >> 4,
    (s16)(2.00 * -48) >> 4,
    (s16)(2.00 * -71) >> 4,
    (s16)(2.00 * -90) >> 4,
    (s16)(2.00 * -106) >> 4,
    (s16)(2.00 * -118) >> 4,
    (s16)(2.00 * -125) >> 4,
    (s16)(2.00 * -128) >> 4, // facing left
    (s16)(2.00 * -125) >> 4,
    (s16)(2.00 * -118) >> 4,
    (s16)(2.00 * -106) >> 4,
    (s16)(2.00 * -90) >> 4,
    (s16)(2.00 * -71) >> 4,
    (s16)(2.00 * -48) >> 4,
    (s16)(2.00 * -24) >> 4,
    0, // facing straight down
    (s16)(2.00 * 24) >> 4,
    (s16)(2.00 * 48) >> 4,
    (s16)(2.00 * 71) >> 4,
    (s16)(2.00 * 90) >> 4,
    (s16)(2.00 * 106) >> 4,
    (s16)(2.00 * 118) >> 4,
    (s16)(2.00 * 125) >> 4,
};

// Y coordinate
const s16 goplanes_fast_sintable32[32] = 
{
    0, // facing right
    (s16)(2.00 * 24) >> 4,
    (s16)(2.00 * 48) >> 4,
    (s16)(2.00 * 71) >> 4,
    (s16)(2.00 * 90) >> 4,
    (s16)(2.00 * 106) >> 4,
    (s16)(2.00 * 118) >> 4,
    (s16)(2.00 * 125) >> 4,
    (s16)(2.00 * 128) >> 4, // facing straight up
    (s16)(2.00 * 125) >> 4,
    (s16)(2.00 * 118) >> 4,
    (s16)(2.00 * 106) >> 4,
    (s16)(2.00 * 90) >> 4,
    (s16)(2.00 * 71) >> 4,
    (s16)(2.00 * 48) >> 4,
    (s16)(2.00 * 24) >> 4,
    0, // facing left
    (s16)(2.00 * -24) >> 4,
    (s16)(2.00 * -48) >> 4,
    (s16)(2.00 * -71) >> 4,
    (s16)(2.00 * -90) >> 4,
    (s16)(2.00 * -106) >> 4,
    (s16)(2.00 * -118) >> 4,
    (s16)(2.00 * -125) >> 4,
    (s16)(2.00 * -128) >> 4, // facing straight down
    (s16)(2.00 * -125) >> 4,
    (s16)(2.00 * -118) >> 4,
    (s16)(2.00 * -106) >> 4,
    (s16)(2.00 * -90) >> 4,
    (s16)(2.00 * -71) >> 4,
    (s16)(2.00 * -48) >> 4,
    (s16)(2.00 * -24) >> 4,
};
*/

const s16 goplanes_fast_costable32[32] = 
{
    16,
    15,
    14,
    13,
    11,
    8,
    6,
    3,
    0,
    -3,
    -6,
    -8,
    -11,
    -13,
    -14,
    -15,
    -16,
    -15,
    -14,
    -13,
    -11,
    -8,
    -6,
    -3,
    0,
    3,
    6,
    8,
    11,
    13,
    14,
    15,
};
const s16 goplanes_fast_sintable32[32] = 
{
    0,
    3,
    6,
    8,
    11,
    13,
    14,
    15,
    16,
    15,
    14,
    13,
    11,
    8,
    6,
    3,
    0,
    -3,
    -6,
    -8,
    -11,
    -13,
    -14,
    -15,
    -16,
    -15,
    -14,
    -13,
    -11,
    -8,
    -6,
    -3,
};


const u16 distance_and_angles_table80x56[4480] = 
{
    0, 512, 1024, 1536, 2048, 2560, 3072, 3584, 4096, 4608, 5120, 5632, 6144, 6656, 7168, 7680, 8192, 8704, 9216, 9728, 10240, 10752, 11264, 11776, 12288, 12800, 13312, 13824, 14336, 14848, 15360, 15872, 16384, 16896, 17408, 17920, 18432, 18944, 19456, 19968, 20480, 20992, 21504, 22016, 22528, 23040, 23552, 24064, 24576, 25088, 25600, 26112, 26624, 27136, 27648, 28160, 28672, 29184, 29696, 30208, 30720, 31232, 31744, 32256, 32768, 33280, 33792, 34304, 34816, 35328, 35840, 36352, 36864, 37376, 37888, 38400, 38912, 39424, 39936, 40448, 
    575, 735, 1106, 1612, 2057, 2567, 3078, 3589, 4100, 4612, 5123, 5635, 6147, 6659, 7170, 7682, 8194, 8706, 9218, 9730, 10242, 10753, 11265, 11777, 12289, 12801, 13313, 13825, 14337, 14849, 15361, 15873, 16385, 16897, 17409, 17921, 18433, 18945, 19457, 19969, 20481, 20992, 21504, 22016, 22528, 23040, 23552, 24064, 24576, 25088, 25600, 26112, 26624, 27136, 27648, 28160, 28672, 29184, 29696, 30208, 30720, 31232, 31744, 32256, 32768, 33280, 33792, 34304, 34816, 35328, 35840, 36352, 36864, 37376, 37888, 38400, 38912, 39424, 39936, 40448, 
    1087, 1132, 1439, 1815, 2258, 2767, 3212, 3723, 4169, 4680, 5191, 5703, 6214, 6726, 7237, 7749, 8196, 8708, 9220, 9732, 10243, 10755, 11267, 11779, 12291, 12803, 13315, 13826, 14338, 14850, 15362, 15874, 16386, 16898, 17410, 17922, 18434, 18946, 19458, 19970, 20482, 20993, 21505, 22017, 22529, 23041, 23553, 24065, 24577, 25089, 25601, 26113, 26625, 27137, 27649, 28161, 28673, 29185, 29697, 30209, 30721, 31233, 31745, 32257, 32769, 33281, 33793, 34305, 34817, 35329, 35841, 36353, 36865, 37377, 37889, 38401, 38913, 39425, 39937, 40449, 
    1599, 1650, 1831, 2143, 2585, 2965, 3410, 3856, 4366, 4812, 5323, 5834, 6281, 6793, 7304, 7815, 8327, 8839, 9286, 9798, 10309, 10821, 11333, 11845, 12356, 12868, 13380, 13892, 14404, 14916, 15427, 15939, 16451, 16963, 17475, 17987, 18435, 18947, 19459, 19971, 20483, 20994, 21506, 22018, 22530, 23042, 23554, 24066, 24578, 25090, 25602, 26114, 26626, 27138, 27650, 28162, 28674, 29186, 29698, 30210, 30722, 31233, 31745, 32257, 32769, 33281, 33793, 34305, 34817, 35329, 35841, 36353, 36865, 37377, 37889, 38401, 38913, 39425, 39937, 40449, 
    2111, 2101, 2284, 2597, 2911, 3291, 3671, 4116, 4562, 5008, 5519, 5965, 6476, 6923, 7435, 7946, 8393, 8905, 9416, 9928, 10439, 10951, 11399, 11910, 12422, 12934, 13446, 13957, 14469, 14981, 15493, 16005, 16452, 16964, 17476, 17988, 18500, 19012, 19524, 20036, 20547, 21059, 21571, 22083, 22595, 23107, 23619, 24131, 24643, 25155, 25667, 26179, 26691, 27203, 27714, 28226, 28738, 29250, 29762, 30274, 30786, 31298, 31810, 32322, 32770, 33282, 33794, 34306, 34818, 35330, 35842, 36354, 36866, 37378, 37890, 38402, 38914, 39426, 39938, 40450, 
    2623, 2615, 2799, 2985, 3299, 3615, 3995, 4376, 4822, 5268, 5714, 6161, 6671, 7118, 7565, 8076, 8588, 9035, 9546, 10058, 10505, 11017, 11528, 12040, 12552, 12999, 13511, 14023, 14535, 15046, 15558, 16070, 16582, 17094, 17541, 18053, 18565, 19077, 19589, 20101, 20612, 21124, 21636, 22148, 22660, 23172, 23684, 24196, 24708, 25220, 25667, 26179, 26691, 27203, 27715, 28227, 28739, 29251, 29763, 30275, 30787, 31299, 31811, 32323, 32835, 33347, 33859, 34370, 34882, 35394, 35906, 36418, 36930, 37442, 37954, 38466, 38978, 39490, 40002, 40514, 
    3135, 3128, 3250, 3436, 3687, 4003, 4319, 4700, 5145, 5527, 5973, 6420, 6866, 7313, 7760, 8271, 8718, 9229, 9676, 10188, 10699, 11147, 11658, 12170, 12617, 13129, 13641, 14152, 14664, 15112, 15623, 16135, 16647, 17159, 17671, 18182, 18630, 19142, 19654, 20166, 20677, 21189, 21701, 22213, 22725, 23237, 23749, 24261, 24708, 25220, 25732, 26244, 26756, 27268, 27780, 28292, 28804, 29316, 29828, 30340, 30851, 31363, 31875, 32387, 32899, 33411, 33923, 34435, 34947, 35459, 35971, 36483, 36931, 37443, 37955, 38467, 38979, 39491, 40003, 40515, 
    3647, 3641, 3763, 3886, 4138, 4390, 4706, 5087, 5468, 5850, 6232, 6678, 7125, 7571, 8018, 8465, 8912, 9423, 9870, 10318, 10829, 11340, 11788, 12299, 12811, 13258, 13770, 14282, 14729, 15241, 15753, 16264, 16776, 17224, 17736, 18247, 18759, 19271, 19783, 20231, 20742, 21254, 21766, 22278, 22790, 23302, 23814, 24325, 24837, 25285, 25797, 26309, 26821, 27333, 27845, 28357, 28868, 29380, 29892, 30404, 30916, 31428, 31940, 32452, 32964, 33476, 33924, 34436, 34948, 35460, 35971, 36483, 36995, 37507, 38019, 38531, 39043, 39555, 40067, 40579, 
    4159, 4154, 4213, 4400, 4588, 4840, 5157, 5474, 5791, 6173, 6555, 6937, 7383, 7830, 8212, 8723, 9170, 9617, 10064, 10511, 11023, 11470, 11981, 12429, 12940, 13388, 13899, 14411, 14859, 15370, 15882, 16394, 16841, 17353, 17865, 18377, 18888, 19336, 19848, 20360, 20871, 21383, 21895, 22343, 22855, 23367, 23878, 24390, 24902, 25414, 25926, 26374, 26886, 27398, 27909, 28421, 28933, 29445, 29957, 30469, 30981, 31493, 32005, 32517, 32964, 33476, 33988, 34500, 35012, 35524, 36036, 36548, 37060, 37572, 38084, 38596, 39108, 39620, 40132, 40644, 
    4671, 4666, 4726, 4850, 5038, 5290, 5543, 5860, 6177, 6495, 6877, 7259, 7705, 8088, 8534, 8917, 9364, 9811, 10258, 10769, 11216, 11664, 12175, 12622, 13134, 13581, 14093, 14540, 15052, 15500, 16011, 16523, 16970, 17482, 17994, 18506, 18953, 19465, 19977, 20489, 21000, 21448, 21960, 22472, 22984, 23495, 23943, 24455, 24967, 25479, 25991, 26503, 27014, 27526, 27974, 28486, 28998, 29510, 30022, 30534, 31045, 31557, 32069, 32581, 33093, 33541, 34053, 34565, 35077, 35589, 36101, 36613, 37124, 37636, 38148, 38660, 39172, 39684, 40196, 40708, 
    5183, 5179, 5239, 5363, 5551, 5740, 5993, 6246, 6563, 6881, 7263, 7581, 7963, 8410, 8792, 9239, 9622, 10069, 10516, 10963, 11410, 11921, 12369, 12816, 13327, 13775, 14222, 14734, 15181, 15693, 16140, 16652, 17164, 17611, 18123, 18635, 19082, 19594, 20106, 20618, 21065, 21577, 22089, 22601, 23048, 23560, 24072, 24584, 25096, 25608, 26055, 26567, 27079, 27591, 28103, 28615, 29127, 29574, 30086, 30598, 31110, 31622, 32134, 32646, 33158, 33670, 34182, 34629, 35141, 35653, 36165, 36677, 37189, 37701, 38213, 38725, 39237, 39749, 40261, 40773, 
    5695, 5691, 5751, 5876, 6001, 6189, 6442, 6696, 6949, 7267, 7585, 7967, 8349, 8732, 9114, 9497, 9944, 10327, 10774, 11221, 11668, 12115, 12562, 13009, 13521, 13968, 14416, 14927, 15375, 15886, 16334, 16845, 17293, 17804, 18252, 18764, 19275, 19723, 20235, 20747, 21194, 21706, 22218, 22730, 23177, 23689, 24201, 24713, 25161, 25672, 26184, 26696, 27208, 27720, 28168, 28679, 29191, 29703, 30215, 30727, 31239, 31687, 32199, 32710, 33222, 33734, 34246, 34758, 35270, 35718, 36230, 36742, 37254, 37765, 38277, 38789, 39301, 39813, 40325, 40837, 
    6207, 6203, 6264, 6325, 6514, 6703, 6892, 7145, 7399, 7717, 7971, 8353, 8671, 9053, 9436, 9819, 10265, 10648, 11095, 11478, 11925, 12372, 12820, 13267, 13714, 14161, 14673, 15120, 15568, 16079, 16527, 16974, 17486, 17933, 18445, 18957, 19404, 19916, 20364, 20875, 21387, 21835, 22347, 22858, 23306, 23818, 24330, 24842, 25289, 25801, 26313, 26825, 27273, 27784, 28296, 28808, 29320, 29768, 30280, 30792, 31303, 31815, 32327, 32839, 33287, 33799, 34311, 34823, 35335, 35846, 36358, 36870, 37318, 37830, 38342, 38854, 39366, 39878, 40390, 40902, 
    6719, 6715, 6776, 6837, 6963, 7152, 7341, 7595, 7848, 8102, 8420, 8738, 9057, 9439, 9758, 10140, 10523, 10970, 11353, 11800, 12183, 12630, 13077, 13524, 13971, 14419, 14866, 15313, 15761, 16272, 16720, 17167, 17679, 18127, 18638, 19086, 19597, 20045, 20557, 21004, 21516, 22028, 22476, 22987, 23499, 23947, 24459, 24970, 25418, 25930, 26442, 26954, 27401, 27913, 28425, 28937, 29385, 29896, 30408, 30920, 31432, 31880, 32392, 32904, 33416, 33927, 34439, 34887, 35399, 35911, 36423, 36935, 37447, 37959, 38470, 38918, 39430, 39942, 40454, 40966, 
    7231, 7228, 7289, 7350, 7475, 7601, 7790, 8044, 8234, 8552, 8806, 9124, 9442, 9760, 10143, 10526, 10908, 11291, 11674, 12057, 12504, 12887, 13334, 13781, 14229, 14676, 15123, 15571, 16018, 16466, 16913, 17425, 17872, 18320, 18831, 19279, 19790, 20238, 20686, 21197, 21709, 22157, 22668, 23116, 23628, 24140, 24587, 25099, 25611, 26059, 26570, 27082, 27530, 28042, 28554, 29065, 29513, 30025, 30537, 31049, 31497, 32009, 32520, 33032, 33544, 33992, 34504, 35016, 35528, 36040, 36551, 36999, 37511, 38023, 38535, 39047, 39559, 40071, 40519, 41031, 
    7743, 7740, 7801, 7863, 7988, 8114, 8303, 8493, 8747, 8937, 9255, 9509, 9827, 10146, 10528, 10847, 11230, 11612, 11995, 12378, 12825, 13208, 13656, 14039, 14486, 14933, 15380, 15828, 16275, 16723, 17170, 17618, 18065, 18513, 19024, 19472, 19983, 20431, 20879, 21390, 21838, 22350, 22797, 23309, 23757, 24268, 24780, 25228, 25740, 26187, 26699, 27211, 27659, 28171, 28682, 29194, 29642, 30154, 30666, 31177, 31625, 32137, 32649, 33161, 33609, 34121, 34632, 35144, 35656, 36104, 36616, 37128, 37640, 38152, 38664, 39111, 39623, 40135, 40647, 41159, 
    8255, 8252, 8250, 8375, 8437, 8626, 8752, 8942, 9196, 9386, 9640, 9958, 10277, 10531, 10914, 11232, 11615, 11934, 12317, 12700, 13083, 13530, 13913, 14360, 14743, 15190, 15638, 16085, 16468, 16916, 17427, 17875, 18322, 18770, 19217, 19665, 20176, 20624, 21071, 21583, 22031, 22542, 22990, 23502, 23949, 24461, 24909, 25421, 25868, 26380, 26828, 27340, 27851, 28299, 28811, 29323, 29771, 30282, 30794, 31306, 31754, 32266, 32778, 33289, 33737, 34249, 34761, 35273, 35721, 36233, 36745, 37256, 37768, 38216, 38728, 39240, 39752, 40264, 40712, 41224, 
    8767, 8764, 8762, 8887, 8949, 9075, 9265, 9455, 9645, 9835, 10089, 10343, 10662, 10980, 11299, 11618, 11936, 12319, 12702, 13021, 13404, 13851, 14234, 14617, 15064, 15447, 15895, 16342, 16789, 17173, 17620, 18068, 18515, 18963, 19474, 19922, 20369, 20817, 21328, 21776, 22224, 22735, 23183, 23631, 24142, 24590, 25102, 25549, 26061, 26509, 27021, 27532, 27980, 28492, 28940, 29452, 29963, 30411, 30923, 31435, 31883, 32394, 32906, 33418, 33866, 34378, 34890, 35337, 35849, 36361, 36873, 37385, 37833, 38345, 38857, 39368, 39880, 40328, 40840, 41352, 
    9279, 9276, 9274, 9336, 9462, 9588, 9714, 9904, 10094, 10284, 10538, 10792, 11111, 11365, 11684, 12003, 12321, 12704, 13023, 13406, 13789, 14172, 14555, 14938, 15385, 15769, 16152, 16599, 17046, 17494, 17877, 18325, 18772, 19220, 19667, 20115, 20562, 21074, 21521, 21969, 22416, 22928, 23376, 23823, 24335, 24783, 25294, 25742, 26254, 26702, 27213, 27661, 28173, 28621, 29132, 29580, 30092, 30604, 31052, 31563, 32075, 32523, 33035, 33547, 33994, 34506, 35018, 35530, 35978, 36490, 37002, 37449, 37961, 38473, 38985, 39497, 39945, 40457, 40969, 41480, 
    9791, 9788, 9786, 9848, 9974, 10100, 10226, 10352, 10543, 10797, 10987, 11241, 11496, 11814, 12069, 12388, 12706, 13025, 13408, 13727, 14110, 14493, 14876, 15259, 15642, 16090, 16473, 16920, 17303, 17751, 18198, 18582, 19029, 19476, 19924, 20371, 20819, 21267, 21714, 22226, 22673, 23121, 23569, 24080, 24528, 24976, 25487, 25935, 26383, 26894, 27342, 27854, 28302, 28813, 29261, 29773, 30285, 30732, 31244, 31692, 32204, 32716, 33163, 33675, 34187, 34635, 35147, 35659, 36106, 36618, 37130, 37578, 38090, 38602, 39114, 39561, 40073, 40585, 41097, 41609, 
    10303, 10300, 10299, 10361, 10487, 10549, 10739, 10865, 11055, 11246, 11436, 11690, 11945, 12199, 12518, 12837, 13091, 13410, 13793, 14112, 14495, 14878, 15197, 15580, 15963, 16411, 16794, 17177, 17624, 18008, 18455, 18902, 19286, 19733, 20181, 20628, 21076, 21523, 21971, 22419, 22866, 23314, 23825, 24273, 24721, 25168, 25680, 26128, 26639, 27087, 27535, 28046, 28494, 29006, 29454, 29965, 30413, 30925, 31373, 31885, 32332, 32844, 33356, 33804, 34316, 34827, 35275, 35787, 36299, 36747, 37259, 37771, 38218, 38730, 39242, 39690, 40202, 40714, 41226, 41673, 
    10815, 10813, 10811, 10873, 10999, 11061, 11187, 11378, 11504, 11694, 11949, 12139, 12394, 12648, 12903, 13222, 13540, 13859, 14178, 14497, 14880, 15199, 15582, 15965, 16348, 16732, 17115, 17498, 17945, 18329, 18712, 19159, 19607, 19990, 20438, 20885, 21333, 21780, 22228, 22675, 23123, 23570, 24018, 24466, 24977, 25425, 25873, 26320, 26832, 27280, 27727, 28239, 28687, 29199, 29646, 30094, 30606, 31054, 31565, 32077, 32525, 33037, 33485, 33996, 34444, 34956, 35468, 35916, 36428, 36875, 37387, 37899, 38411, 38859, 39371, 39882, 40330, 40842, 41354, 41802, 
    11327, 11325, 11323, 11385, 11447, 11574, 11700, 11826, 12017, 12207, 12397, 12588, 12842, 13097, 13352, 13670, 13925, 14244, 14563, 14882, 15201, 15584, 15903, 16286, 16669, 17052, 17436, 17819, 18202, 18650, 19033, 19480, 19864, 20311, 20695, 21142, 21590, 22037, 22485, 22932, 23380, 23827, 24275, 24722, 25170, 25618, 26065, 26577, 27025, 27472, 27984, 28432, 28880, 29391, 29839, 30287, 30799, 31246, 31758, 32206, 32718, 33165, 33677, 34125, 34637, 35085, 35596, 36108, 36556, 37068, 37580, 38028, 38539, 38987, 39499, 40011, 40459, 40971, 41483, 41994, 
    11839, 11837, 11835, 11897, 11960, 12086, 12212, 12339, 12465, 12656, 12846, 13037, 13291, 13546, 13801, 14055, 14374, 14629, 14948, 15267, 15586, 15969, 16288, 16671, 16990, 17373, 17757, 18140, 18523, 18970, 19354, 19737, 20184, 20568, 21015, 21463, 21846, 22294, 22741, 23189, 23636, 24084, 24532, 24979, 25427, 25874, 26322, 26770, 27217, 27729, 28177, 28624, 29072, 29584, 30032, 30479, 30991, 31439, 31951, 32398, 32910, 33358, 33870, 34318, 34829, 35277, 35789, 36237, 36749, 37196, 37708, 38220, 38668, 39180, 39628, 40139, 40651, 41099, 41611, 42123, 
    12351, 12349, 12347, 12410, 12472, 12598, 12661, 12851, 12978, 13168, 13359, 13549, 13740, 13995, 14249, 14504, 14759, 15078, 15397, 15652, 15971, 16354, 16673, 16992, 17375, 17758, 18141, 18461, 18908, 19291, 19675, 20058, 20505, 20889, 21272, 21720, 22167, 22551, 22998, 23446, 23893, 24341, 24724, 25172, 25620, 26131, 26579, 27026, 27474, 27922, 28369, 28817, 29329, 29777, 30224, 30736, 31184, 31631, 32143, 32591, 33039, 33551, 33998, 34510, 34958, 35470, 35917, 36429, 36877, 37389, 37901, 38349, 38860, 39308, 39820, 40268, 40780, 41292, 41739, 42251, 
    12863, 12861, 12859, 12922, 12984, 13047, 13173, 13300, 13426, 13617, 13807, 13998, 14189, 14443, 14698, 14953, 15208, 15463, 15781, 16100, 16419, 16738, 17058, 17377, 17760, 18079, 18462, 18845, 19229, 19612, 19995, 20379, 20762, 21210, 21593, 22040, 22424, 22871, 23255, 23702, 24150, 24597, 25045, 25429, 25876, 26324, 26771, 27219, 27667, 28178, 28626, 29074, 29521, 29969, 30481, 30929, 31376, 31824, 32336, 32784, 33295, 33743, 34191, 34703, 35150, 35662, 36110, 36622, 37070, 37581, 38029, 38541, 38989, 39501, 39949, 40460, 40972, 41420, 41932, 42380, 
    13375, 13373, 13371, 13434, 13496, 13559, 13685, 13812, 13939, 14129, 14256, 14446, 14701, 14892, 15147, 15402, 15656, 15911, 16166, 16485, 16804, 17123, 17442, 17761, 18145, 18464, 18847, 19166, 19550, 19933, 20316, 20699, 21083, 21530, 21914, 22297, 22745, 23128, 23576, 23959, 24407, 24854, 25302, 25685, 26133, 26581, 27028, 27476, 27923, 28371, 28819, 29266, 29778, 30226, 30673, 31121, 31569, 32081, 32528, 32976, 33488, 33936, 34383, 34895, 35343, 35855, 36303, 36750, 37262, 37710, 38222, 38670, 39181, 39629, 40141, 40653, 41101, 41613, 42060, 42572, 
    13887, 13885, 13884, 13946, 14009, 14071, 14198, 14324, 14451, 14578, 14768, 14959, 15150, 15341, 15595, 15850, 16105, 16360, 16615, 16934, 17189, 17508, 17827, 18146, 18465, 18849, 19168, 19551, 19934, 20254, 20637, 21020, 21404, 21851, 22234, 22618, 23065, 23449, 23832, 24280, 24727, 25111, 25558, 26006, 26390, 26837, 27285, 27732, 28180, 28628, 29075, 29523, 29971, 30418, 30866, 31378, 31826, 32273, 32721, 33233, 33680, 34128, 34576, 35088, 35536, 36047, 36495, 36943, 37455, 37902, 38414, 38862, 39374, 39822, 40334, 40781, 41293, 41741, 42253, 42701, 
    14399, 14397, 14396, 14458, 14521, 14583, 14710, 14773, 14899, 15090, 15217, 15407, 15598, 15789, 16044, 16299, 16490, 16809, 17064, 17319, 17638, 17957, 18212, 18531, 18914, 19233, 19552, 19936, 20255, 20638, 21022, 21405, 21788, 22172, 22555, 22939, 23322, 23769, 24153, 24600, 24984, 25432, 25815, 26263, 26710, 27158, 27541, 27989, 28437, 28884, 29332, 29780, 30227, 30675, 31123, 31570, 32018, 32530, 32978, 33425, 33873, 34321, 34833, 35280, 35728, 36240, 36688, 37135, 37647, 38095, 38607, 39055, 39566, 40014, 40462, 40974, 41422, 41933, 42381, 42893, 
    14911, 14909, 14908, 14970, 15033, 15096, 15158, 15285, 15412, 15538, 15729, 15920, 16111, 16302, 16492, 16747, 16938, 17193, 17512, 17767, 18022, 18341, 18660, 18980, 19299, 19618, 19937, 20256, 20640, 21023, 21342, 21726, 22109, 22492, 22876, 23259, 23643, 24090, 24474, 24857, 25305, 25688, 26136, 26519, 26967, 27414, 27862, 28246, 28693, 29141, 29589, 30036, 30484, 30932, 31379, 31827, 32275, 32722, 33170, 33618, 34130, 34577, 35025, 35473, 35985, 36432, 36880, 37392, 37840, 38287, 38799, 39247, 39695, 40207, 40654, 41166, 41614, 42126, 42574, 43086, 
    15423, 15421, 15420, 15483, 15545, 15608, 15671, 15797, 15924, 16051, 16178, 16368, 16559, 16750, 16941, 17196, 17451, 17642, 17897, 18216, 18471, 18726, 19045, 19364, 19683, 20003, 20322, 20641, 21024, 21344, 21727, 22110, 22430, 22813, 23196, 23580, 23963, 24411, 24794, 25178, 25625, 26009, 26392, 26840, 27288, 27671, 28119, 28566, 28950, 29398, 29845, 30293, 30740, 31188, 31636, 32084, 32531, 32979, 33427, 33874, 34322, 34770, 35282, 35729, 36177, 36625, 37073, 37584, 38032, 38480, 38992, 39440, 39951, 40399, 40847, 41359, 41807, 42318, 42766, 43278, 
    15935, 15933, 15932, 15995, 16057, 16120, 16183, 16310, 16436, 16563, 16690, 16881, 17008, 17199, 17453, 17644, 17899, 18090, 18345, 18600, 18920, 19175, 19494, 19749, 20068, 20387, 20707, 21026, 21409, 21728, 22112, 22431, 22814, 23198, 23581, 23965, 24348, 24731, 25115, 25498, 25882, 26329, 26713, 27161, 27544, 27992, 28375, 28823, 29270, 29654, 30102, 30549, 30997, 31445, 31892, 32340, 32788, 33235, 33683, 34131, 34579, 35026, 35474, 35922, 36370, 36881, 37329, 37777, 38225, 38736, 39184, 39632, 40144, 40592, 41039, 41551, 41999, 42511, 42959, 43406, 
    16447, 16445, 16444, 16507, 16506, 16632, 16695, 16822, 16885, 17012, 17202, 17329, 17520, 17711, 17902, 18093, 18348, 18539, 18794, 19049, 19304, 19623, 19878, 20198, 20517, 20772, 21091, 21410, 21794, 22113, 22432, 22816, 23199, 23518, 23902, 24285, 24669, 25052, 25436, 25819, 26203, 26650, 27034, 27417, 27865, 28248, 28696, 29079, 29527, 29975, 30358, 30806, 31254, 31701, 32149, 32597, 32980, 33428, 33876, 34323, 34835, 35283, 35731, 36178, 36626, 37074, 37522, 37969, 38481, 38929, 39377, 39888, 40336, 40784, 41232, 41744, 42191, 42703, 43151, 43599, 
    16959, 16957, 16956, 17019, 17018, 17144, 17207, 17270, 17397, 17524, 17651, 17842, 17969, 18159, 18350, 18541, 18796, 18987, 19242, 19498, 19753, 20008, 20327, 20582, 20901, 21220, 21540, 21859, 22178, 22498, 22817, 23200, 23520, 23903, 24286, 24606, 24989, 25373, 25756, 26140, 26523, 26971, 27354, 27738, 28185, 28569, 28952, 29400, 29784, 30231, 30679, 31063, 31510, 31958, 32406, 32853, 33301, 33685, 34132, 34580, 35028, 35475, 35923, 36371, 36883, 37330, 37778, 38226, 38674, 39121, 39633, 40081, 40529, 40977, 41488, 41936, 42384, 42896, 43344, 43791, 
    17471, 17469, 17468, 17531, 17530, 17593, 17719, 17782, 17909, 18036, 18163, 18290, 18481, 18672, 18863, 19054, 19245, 19500, 19691, 19946, 20201, 20456, 20711, 21031, 21286, 21605, 21924, 22244, 22563, 22882, 23202, 23585, 23904, 24288, 24607, 24990, 25374, 25693, 26077, 26460, 26844, 27291, 27675, 28058, 28442, 28889, 29273, 29721, 30104, 30552, 30935, 31383, 31831, 32214, 32662, 33110, 33557, 33941, 34389, 34836, 35284, 35732, 36180, 36627, 37075, 37523, 37971, 38482, 38930, 39378, 39826, 40273, 40721, 41233, 41681, 42129, 42640, 43088, 43536, 44048, 
    17983, 17981, 17980, 18043, 18042, 18105, 18232, 18295, 18421, 18548, 18675, 18802, 18993, 19120, 19311, 19502, 19693, 19948, 20139, 20395, 20650, 20905, 21160, 21479, 21734, 22054, 22309, 22628, 22947, 23267, 23586, 23969, 24289, 24608, 24992, 25311, 25694, 26078, 26461, 26845, 27228, 27612, 27995, 28379, 28762, 29210, 29594, 29977, 30425, 30808, 31256, 31640, 32087, 32535, 32919, 33366, 33814, 34262, 34645, 35093, 35541, 35988, 36436, 36884, 37332, 37779, 38227, 38675, 39123, 39570, 40082, 40530, 40978, 41425, 41873, 42385, 42833, 43281, 43728, 44240, 
    18495, 18493, 18492, 18491, 18554, 18617, 18680, 18807, 18934, 18997, 19124, 19315, 19442, 19633, 19824, 20015, 20206, 20397, 20588, 20843, 21098, 21353, 21608, 21864, 22183, 22438, 22757, 23077, 23332, 23651, 23971, 24354, 24673, 24993, 25376, 25696, 26079, 26398, 26782, 27165, 27549, 27932, 28316, 28699, 29083, 29531, 29914, 30298, 30745, 31129, 31513, 31960, 32344, 32791, 33239, 33623, 34070, 34518, 34966, 35349, 35797, 36245, 36693, 37140, 37588, 38036, 38484, 38931, 39379, 39827, 40275, 40722, 41170, 41682, 42130, 42577, 43025, 43537, 43985, 44433, 
    19007, 19005, 19004, 19003, 19066, 19129, 19192, 19319, 19382, 19509, 19636, 19763, 19954, 20081, 20272, 20463, 20654, 20845, 21100, 21291, 21547, 21802, 22057, 22312, 22567, 22887, 23142, 23461, 23781, 24100, 24419, 24739, 25058, 25377, 25697, 26080, 26400, 26783, 27166, 27550, 27869, 28253, 28636, 29020, 29404, 29851, 30235, 30618, 31002, 31449, 31833, 32281, 32664, 33112, 33496, 33943, 34327, 34775, 35222, 35670, 36054, 36501, 36949, 37397, 37845, 38292, 38740, 39188, 39635, 40083, 40531, 40979, 41427, 41874, 42322, 42834, 43282, 43729, 44177, 44625, 
    19519, 19517, 19516, 19515, 19578, 19641, 19704, 19831, 19894, 20021, 20148, 20275, 20402, 20593, 20720, 20911, 21103, 21358, 21549, 21740, 21995, 22250, 22505, 22761, 23016, 23271, 23590, 23846, 24165, 24484, 24804, 25123, 25442, 25762, 26081, 26465, 26784, 27168, 27487, 27870, 28254, 28637, 29021, 29405, 29788, 30172, 30555, 30939, 31322, 31770, 32154, 32537, 32985, 33368, 33816, 34200, 34647, 35095, 35479, 35926, 36374, 36758, 37206, 37653, 38101, 38549, 38996, 39444, 39892, 40340, 40787, 41235, 41683, 42131, 42579, 43026, 43474, 43922, 44434, 44881, 
    20031, 20029, 20028, 20027, 20090, 20153, 20216, 20279, 20406, 20533, 20660, 20787, 20915, 21042, 21233, 21424, 21615, 21806, 21997, 22252, 22443, 22699, 22954, 23209, 23464, 23720, 23975, 24294, 24614, 24869, 25188, 25508, 25827, 26146, 26466, 26849, 27169, 27552, 27872, 28255, 28574, 28958, 29342, 29725, 30109, 30492, 30876, 31259, 31643, 32090, 32474, 32858, 33305, 33689, 34073, 34520, 34904, 35352, 35799, 36183, 36631, 37078, 37462, 37910, 38357, 38805, 39253, 39701, 40148, 40596, 41044, 41492, 41939, 42387, 42835, 43283, 43731, 44178, 44626, 45074, 
    20543, 20541, 20540, 20539, 20603, 20666, 20729, 20792, 20919, 21046, 21109, 21236, 21427, 21554, 21745, 21872, 22063, 22254, 22446, 22701, 22892, 23147, 23402, 23658, 23913, 24168, 24423, 24743, 24998, 25317, 25637, 25892, 26211, 26531, 26850, 27234, 27553, 27873, 28256, 28576, 28959, 29343, 29726, 30046, 30429, 30813, 31196, 31580, 31963, 32411, 32795, 33178, 33562, 34009, 34393, 34841, 35224, 35672, 36056, 36503, 36887, 37335, 37782, 38230, 38614, 39062, 39509, 39957, 40405, 40853, 41236, 41684, 42132, 42580, 43027, 43539, 43987, 44435, 44883, 45330, 
    21055, 21054, 21053, 21052, 21115, 21178, 21241, 21304, 21431, 21494, 21621, 21748, 21875, 22066, 22193, 22384, 22576, 22767, 22958, 23149, 23340, 23596, 23851, 24106, 24361, 24617, 24872, 25127, 25446, 25702, 26021, 26341, 26660, 26979, 27299, 27618, 27938, 28257, 28641, 28960, 29343, 29663, 30047, 30430, 30814, 31197, 31517, 31900, 32348, 32731, 33115, 33499, 33882, 34330, 34714, 35097, 35545, 35929, 36376, 36760, 37208, 37591, 38039, 38487, 38934, 39318, 39766, 40214, 40661, 41109, 41493, 41941, 42388, 42836, 43284, 43732, 44179, 44627, 45075, 45587, 
    21567, 21566, 21565, 21564, 21627, 21690, 21753, 21816, 21943, 22006, 22133, 22260, 22387, 22514, 22706, 22833, 23024, 23215, 23406, 23597, 23853, 24044, 24299, 24554, 24746, 25065, 25320, 25576, 25831, 26150, 26406, 26725, 27044, 27364, 27683, 28003, 28322, 28642, 29025, 29344, 29728, 30047, 30431, 30751, 31134, 31518, 31901, 32285, 32668, 33052, 33436, 33819, 34203, 34586, 35034, 35418, 35865, 36249, 36633, 37080, 37464, 37912, 38359, 38743, 39191, 39639, 40022, 40470, 40918, 41365, 41813, 42197, 42645, 43092, 43540, 43988, 44436, 44884, 45331, 45779, 
    22079, 22078, 22077, 22076, 22139, 22202, 22265, 22328, 22391, 22518, 22645, 22772, 22900, 23027, 23154, 23345, 23536, 23663, 23855, 24110, 24301, 24492, 24748, 25003, 25194, 25449, 25705, 26024, 26279, 26535, 26854, 27173, 27429, 27748, 28068, 28387, 28707, 29026, 29409, 29729, 30048, 30432, 30751, 31135, 31519, 31838, 32222, 32605, 32989, 33372, 33756, 34140, 34523, 34907, 35354, 35738, 36122, 36569, 36953, 37401, 37784, 38232, 38616, 39064, 39447, 39895, 40343, 40726, 41174, 41622, 42070, 42517, 42901, 43349, 43797, 44244, 44692, 45140, 45588, 46035, 
    22591, 22590, 22589, 22588, 22651, 22714, 22777, 22840, 22903, 23030, 23094, 23221, 23348, 23539, 23666, 23793, 23985, 24176, 24367, 24558, 24749, 25005, 25196, 25451, 25642, 25898, 26153, 26408, 26728, 26983, 27302, 27558, 27877, 28197, 28452, 28772, 29091, 29410, 29794, 30113, 30433, 30816, 31136, 31519, 31839, 32223, 32606, 32990, 33309, 33693, 34076, 34460, 34844, 35291, 35675, 36059, 36442, 36890, 37274, 37657, 38105, 38489, 38936, 39320, 39768, 40151, 40599, 41047, 41431, 41878, 42326, 42774, 43222, 43605, 44053, 44501, 44949, 45396, 45844, 46292, 
    23103, 23102, 23101, 23100, 23163, 23226, 23289, 23352, 23415, 23543, 23606, 23733, 23860, 23987, 24178, 24306, 24497, 24624, 24815, 25006, 25198, 25453, 25644, 25900, 26155, 26346, 26601, 26857, 27176, 27432, 27687, 28006, 28262, 28581, 28901, 29220, 29539, 29859, 30178, 30498, 30817, 31201, 31520, 31840, 32223, 32607, 32927, 33310, 33694, 34077, 34461, 34844, 35228, 35612, 35995, 36379, 36763, 37146, 37594, 37978, 38425, 38809, 39193, 39640, 40024, 40472, 40920, 41303, 41751, 42199, 42582, 43030, 43478, 43926, 44309, 44757, 45205, 45653, 46100, 46548, 
    23615, 23614, 23613, 23612, 23675, 23738, 23801, 23864, 23928, 23991, 24118, 24245, 24372, 24499, 24627, 24818, 24945, 25136, 25328, 25519, 25710, 25901, 26093, 26348, 26603, 26795, 27050, 27305, 27561, 27880, 28135, 28391, 28710, 28966, 29285, 29604, 29924, 30243, 30563, 30882, 31202, 31521, 31905, 32224, 32608, 32927, 33311, 33695, 34014, 34398, 34781, 35165, 35549, 35932, 36316, 36699, 37083, 37467, 37914, 38298, 38682, 39129, 39513, 39961, 40344, 40792, 41176, 41624, 42007, 42455, 42903, 43287, 43734, 44182, 44630, 45014, 45461, 45909, 46357, 46805, 
    24127, 24126, 24125, 24124, 24187, 24250, 24313, 24377, 24440, 24503, 24630, 24757, 24884, 25012, 25139, 25266, 25457, 25585, 25776, 25967, 26158, 26350, 26605, 26796, 27052, 27243, 27498, 27754, 28009, 28264, 28584, 28839, 29095, 29414, 29733, 29989, 30308, 30628, 30947, 31267, 31586, 31906, 32289, 32609, 32992, 33312, 33695, 34015, 34399, 34782, 35102, 35485, 35869, 36253, 36636, 37020, 37404, 37851, 38235, 38618, 39002, 39450, 39834, 40217, 40665, 41049, 41496, 41880, 42328, 42711, 43159, 43607, 43991, 44438, 44886, 45334, 45718, 46165, 46613, 47061, 
    24639, 24638, 24637, 24636, 24699, 24762, 24762, 24889, 24952, 25015, 25142, 25205, 25333, 25460, 25651, 25778, 25906, 26097, 26288, 26415, 26671, 26862, 27053, 27245, 27500, 27691, 27947, 28202, 28457, 28713, 28968, 29288, 29543, 29798, 30118, 30437, 30757, 31012, 31332, 31651, 31971, 32354, 32674, 32993, 33313, 33696, 34016, 34399, 34783, 35103, 35486, 35870, 36253, 36637, 36957, 37404, 37788, 38172, 38555, 38939, 39323, 39706, 40154, 40538, 40985, 41369, 41753, 42200, 42584, 43032, 43480, 43863, 44311, 44695, 45143, 45590, 46038, 46422, 46870, 47317, 
    25151, 25150, 25149, 25148, 25211, 25274, 25274, 25337, 25464, 25527, 25654, 25718, 25845, 25972, 26099, 26227, 26418, 26545, 26736, 26928, 27119, 27310, 27502, 27757, 27948, 28204, 28395, 28650, 28906, 29161, 29416, 29672, 29991, 30247, 30566, 30822, 31141, 31461, 31780, 32100, 32419, 32739, 33058, 33378, 33697, 34081, 34400, 34784, 35103, 35487, 35871, 36190, 36574, 36957, 37341, 37725, 38108, 38492, 38876, 39259, 39643, 40027, 40474, 40858, 41242, 41689, 42073, 42521, 42905, 43352, 43736, 44184, 44567, 45015, 45463, 45847, 46294, 46742, 47126, 47574, 
    25663, 25662, 25661, 25660, 25723, 25723, 25786, 25849, 25976, 26039, 26103, 26230, 26357, 26484, 26612, 26739, 26866, 27057, 27249, 27376, 27567, 27759, 28014, 28205, 28397, 28652, 28843, 29099, 29354, 29609, 29865, 30120, 30376, 30695, 30951, 31270, 31525, 31845, 32164, 32484, 32803, 33123, 33442, 33762, 34082, 34465, 34785, 35104, 35488, 35871, 36191, 36575, 36958, 37278, 37661, 38045, 38429, 38812, 39196, 39580, 39963, 40347, 40795, 41178, 41562, 42010, 42394, 42777, 43225, 43609, 44056, 44440, 44888, 45272, 45719, 46167, 46551, 46999, 47446, 47830, 
    26175, 26174, 26173, 26172, 26235, 26235, 26298, 26361, 26424, 26551, 26615, 26742, 26869, 26996, 27124, 27251, 27378, 27570, 27697, 27888, 28080, 28271, 28462, 28654, 28845, 29100, 29292, 29547, 29802, 30058, 30313, 30569, 30824, 31079, 31399, 31654, 31974, 32293, 32549, 32868, 33188, 33507, 33827, 34146, 34466, 34850, 35169, 35489, 35872, 36192, 36575, 36895, 37279, 37662, 38046, 38429, 38749, 39133, 39516, 39900, 40284, 40731, 41115, 41499, 41882, 42266, 42714, 43098, 43545, 43929, 44313, 44760, 45144, 45592, 45976, 46423, 46871, 47255, 47703, 48150, 
    26687, 26686, 26685, 26684, 26747, 26747, 26810, 26873, 26936, 27064, 27127, 27254, 27317, 27445, 27572, 27699, 27891, 28018, 28209, 28336, 28528, 28719, 28910, 29102, 29357, 29549, 29804, 29995, 30251, 30506, 30762, 31017, 31272, 31528, 31847, 32103, 32358, 32678, 32997, 33317, 33572, 33892, 34211, 34531, 34850, 35234, 35553, 35873, 36257, 36576, 36960, 37279, 37663, 37983, 38366, 38750, 39134, 39517, 39901, 40284, 40668, 41052, 41435, 41819, 42203, 42587, 43034, 43418, 43802, 44249, 44633, 45081, 45465, 45912, 46296, 46744, 47128, 47575, 47959, 48407, 
    27199, 27198, 27197, 27196, 27259, 27259, 27322, 27385, 27448, 27576, 27639, 27766, 27830, 27957, 28084, 28211, 28339, 28530, 28657, 28849, 29040, 29231, 29423, 29614, 29805, 29997, 30252, 30444, 30699, 30954, 31210, 31465, 31721, 31976, 32232, 32551, 32807, 33126, 33382, 33701, 34021, 34340, 34596, 34915, 35299, 35618, 35938, 36257, 36641, 36961, 37280, 37664, 37983, 38367, 38751, 39134, 39454, 39838, 40221, 40605, 40989, 41372, 41756, 42140, 42523, 42907, 43355, 43738, 44122, 44570, 44953, 45337, 45785, 46169, 46616, 47000, 47448, 47832, 48279, 48727, 
    27711, 27710, 27709, 27708, 27772, 27771, 27834, 27897, 27961, 28024, 28151, 28214, 28342, 28469, 28596, 28724, 28851, 28978, 29170, 29297, 29488, 29680, 29871, 30062, 30254, 30509, 30701, 30892, 31147, 31403, 31658, 31914, 32169, 32424, 32680, 32935, 33255, 33510, 33830, 34085, 34405, 34724, 35044, 35364, 35683, 36003, 36322, 36642, 36961, 37345, 37665, 38048, 38368, 38751, 39071, 39455, 39838, 40222, 40542, 40925, 41309, 41693, 42076, 42460, 42844, 43291, 43675, 44059, 44442, 44826, 45274, 45658, 46105, 46489, 46873, 47321, 47704, 48152, 48536, 48984, 
    28223, 28222, 28221, 28220, 28284, 28283, 28346, 28409, 28473, 28536, 28663, 28727, 28854, 28981, 29109, 29236, 29363, 29490, 29618, 29809, 30001, 30128, 30319, 30511, 30766, 30957, 31149, 31404, 31596, 31851, 32106, 32362, 32617, 32873, 33128, 33384, 33639, 33959, 34214, 34534, 34853, 35109, 35428, 35748, 36067, 36387, 36707, 37026, 37410, 37729, 38049, 38433, 38752, 39136, 39455, 39839, 40159, 40542, 40926, 41310, 41693, 42077, 42461, 42844, 43228, 43612, 43995, 44379, 44763, 45146, 45594, 45978, 46362, 46809, 47193, 47641, 48025, 48472, 48856, 49304, 
};

const s16 radar_screenpos_x[256] = 
{
    288,
    287,
    287,
    287,
    287,
    287,
    286,
    286,
    285,
    284,
    284,
    283,
    282,
    281,
    280,
    279,
    278,
    277,
    275,
    274,
    272,
    271,
    269,
    268,
    266,
    264,
    262,
    260,
    258,
    256,
    254,
    252,
    250,
    248,
    245,
    243,
    241,
    238,
    236,
    233,
    231,
    228,
    225,
    223,
    220,
    217,
    214,
    211,
    208,
    206,
    203,
    200,
    197,
    194,
    191,
    188,
    184,
    181,
    178,
    175,
    172,
    169,
    166,
    163,
    160,
    157,
    154,
    151,
    148,
    145,
    142,
    139,
    136,
    132,
    129,
    126,
    123,
    120,
    117,
    114,
    112,
    109,
    106,
    103,
    100,
    97,
    95,
    92,
    89,
    87,
    84,
    82,
    79,
    77,
    75,
    72,
    70,
    68,
    66,
    64,
    62,
    60,
    58,
    56,
    54,
    52,
    51,
    49,
    48,
    46,
    45,
    43,
    42,
    41,
    40,
    39,
    38,
    37,
    36,
    36,
    35,
    34,
    34,
    33,
    33,
    33,
    33,
    33,
    32,
    33,
    33,
    33,
    33,
    33,
    34,
    34,
    35,
    36,
    36,
    37,
    38,
    39,
    40,
    41,
    42,
    43,
    45,
    46,
    48,
    49,
    51,
    52,
    54,
    56,
    58,
    60,
    62,
    64,
    66,
    68,
    70,
    72,
    75,
    77,
    79,
    82,
    84,
    87,
    89,
    92,
    95,
    97,
    100,
    103,
    106,
    109,
    112,
    114,
    117,
    120,
    123,
    126,
    129,
    132,
    136,
    139,
    142,
    145,
    148,
    151,
    154,
    157,
    160,
    163,
    166,
    169,
    172,
    175,
    178,
    181,
    184,
    188,
    191,
    194,
    197,
    200,
    203,
    206,
    208,
    211,
    214,
    217,
    220,
    223,
    225,
    228,
    231,
    233,
    236,
    238,
    241,
    243,
    245,
    248,
    250,
    252,
    254,
    256,
    258,
    260,
    262,
    264,
    266,
    268,
    269,
    271,
    272,
    274,
    275,
    277,
    278,
    279,
    280,
    281,
    282,
    283,
    284,
    284,
    285,
    286,
    286,
    287,
    287,
    287,
    287,
    287,
};
const s16 radar_screenpos_y[256] = 
{
    112,
    115,
    118,
    121,
    124,
    127,
    130,
    133,
    136,
    140,
    143,
    146,
    149,
    152,
    155,
    158,
    160,
    163,
    166,
    169,
    172,
    175,
    177,
    180,
    183,
    185,
    188,
    190,
    193,
    195,
    197,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    200,
    197,
    195,
    193,
    190,
    188,
    185,
    183,
    180,
    177,
    175,
    172,
    169,
    166,
    163,
    160,
    158,
    155,
    152,
    149,
    146,
    143,
    140,
    136,
    133,
    130,
    127,
    124,
    121,
    118,
    115,
    112,
    109,
    106,
    103,
    100,
    97,
    94,
    91,
    88,
    84,
    81,
    78,
    75,
    72,
    69,
    66,
    64,
    61,
    58,
    55,
    52,
    49,
    47,
    44,
    41,
    39,
    36,
    34,
    31,
    29,
    27,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    24,
    27,
    29,
    31,
    34,
    36,
    39,
    41,
    44,
    47,
    49,
    52,
    55,
    58,
    61,
    64,
    66,
    69,
    72,
    75,
    78,
    81,
    84,
    88,
    91,
    94,
    97,
    100,
    103,
    106,
    109,
};


s16 mathutils_abs(s16 value) // terrible and badly implemented.
{
    if (value < 0)
    {
        value = -value;
    }
    return value;
}

u16 mathutils_isnegative(s16 value)
{
    if (value < 0)
    {
        return 1;
    }

    return 0;
}

u16 GetShiftValueFromValue(u16 value)
{
    u16 shiftValue = 0;

    while (value > 1)
    {
        shiftValue++;
        value >>= 1;
    }

    return shiftValue;
}
